﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace MMDSScv.Konfiguration
{
    public class Config
    {
        /// <summary>
        /// Verzeichnispfad in dem nach Bildern gesucht werden soll
        /// </summary>
        [XmlIgnore]
        public string DirectoryPath
        {
            get { return FileManagerConfig.FilePath; }
            set { FileManagerConfig.FilePath = value; }
        }
        //public string DirectoryPath = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures);

        /// <summary>
        /// Nach diesen Dateiendungen wird gesucht
        /// </summary>
        [XmlIgnore]
        public string[] AllowExt
        {
            get { return FileManagerConfig.AllowExt; }
            set { FileManagerConfig.AllowExt = value; }
        }
        //public string[] AllowExt = { ".jpg", ".bmp", ".jpeg", ".JPG", ".BMP", ".JPEG" };

        /// <summary>
        /// Sollen auch Unterverzeichnisse durchsucht werden?
        /// </summary>
        [XmlIgnore]
        public bool SearchSubDirs
        {
            get { return FileManagerConfig.SearchSubDirs; }
            set { FileManagerConfig.SearchSubDirs = value; }
        }
        //public bool SearchSubDirs = true;

        /// <summary>
        /// Intervall nach dem ein Bildwechsel erfolgt
        /// </summary>
        public int TimerInterval = 5000;

        /// <summary>
        /// Wenn true wird auf jeden Bildschirm gleichzeitig das Bild gewechselt, bei false abwechselnd
        /// </summary>
        public bool ChangeAlternate = true;

        /// <summary>
        /// Speichert alle relevanten Daten für den Dateizugriff
        /// </summary>
        public MMDSScv.ScreenSaver.FileManagmentConfig FileManagerConfig = new ScreenSaver.FileManagmentConfig();

        /// <summary>
        /// Konfiguration für die InfoBox
        /// </summary>
        public PictureInfoBoxConfig PictureInfoBoxConfig = new PictureInfoBoxConfig();
    }

    public class PictureInfoBoxConfig
    {
        public SpecialLabels.SelfPositionatingLabelConfig LabelConfig = new SpecialLabels.SelfPositionatingLabelConfig();

        /// <summary>
        /// Soll der Dateiname angezeigt werden?
        /// </summary>
        public bool ShowFileName = true;

        /// <summary>
        /// Soll der Bildtitel angezeigt werden?
        /// </summary>
        public bool ShowTitle = true;

        /// <summary>
        /// Soll der Fotograf angezeigt werden?
        /// </summary>
        public bool ShowPhotographer = true;

    }
}
