﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MMDSScv
{
    class Program
    {
        static ScreenSaver.ScreenSaverMain screenSaver = new ScreenSaver.ScreenSaverMain();
        [STAThread]
        static void Main(string[] args)
        {
            
            if (args.Length > 0) //Anahnd des Parametes feststellen, in welchem Modus gestartet werden soll
            {
                // Konfiguration
                if ((args[0].ToLower().Trim().Substring(0, 2) == "/c")) // längere Umwandlung nötig da config - Parameter in der Form "/c:xxxxx" übergeben wird
                {
                    ShowSettingsDialog(); //Konfigurationsdialog anzeigen
                }

                // Start
                else if (args[0].ToLower() == "/s")
                {
                    // Bildschirmschoner starten
                    RunScreenSaver();
                }

                //Preview Modus aus dem Einstellungsdialog (nicht Windows-PreView!)
                else if (args[0].ToLower() == "/prev")
                {
                    if (args.Length > 1) //Wenn ein weiterer Parameter dranhängt, steht in diesem die Konfigurationsdatei für die Preview
                    {
                        Konfiguration.Settings set = new Konfiguration.Settings(args[1]); //PreviewKonfig-Datei laden
                        screenSaver = new ScreenSaver.ScreenSaverMain(set.currConfig); //neues Screensaverobjekt mit der PreViewKonfigDatei erstellen
                        screenSaver.Run(); //Und Bildschirmschoner starten
                    }               
                }
            }
            //Parameterloser Start - was soll passieren, wenn kein Parameter angegeben wird
            else
            {
                ShowSettingsDialog();
                //RunScreenSaver();
            }
            
        }

        /// <summary>
        /// Zeigt den Einstellungen-Dialog
        /// </summary>
        static void ShowSettingsDialog()
        {
            Konfiguration.Settings set = new Konfiguration.Settings();
            set.ShowSettingsDialog();
        }

        /// <summary>
        /// Startet den Bildschirmschoner
        /// </summary>
        static void RunScreenSaver()
        {
            screenSaver.Run();
        }
    }
}
